<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>The OSGi Plugin - Gradle User Guide Version 4.2</title><link xmlns:xslthl="http://xslthl.sf.net" type="text/css" rel="stylesheet" href="base.css"><link xmlns:xslthl="http://xslthl.sf.net" type="text/css" rel="stylesheet" href="docs.css"><link xmlns:xslthl="http://xslthl.sf.net" type="text/css" rel="stylesheet" href="userguide.css"><meta content="DocBook XSL Stylesheets V1.75.2" name="generator"><link rel="home" href="userguide.html" title="Gradle User Guide Version 4.2"><link rel="up" href="pt05.html" title="Part&nbsp;V.&nbsp;Building JVM projects"><link rel="prev" href="jacoco_plugin.html" title="The JaCoCo Plugin - Gradle User Guide Version 4.2"><link rel="next" href="eclipse_plugin.html" title="The Eclipse Plugins - Gradle User Guide Version 4.2"></head><body><div class="navheader"><div><div class="navbar"><a xmlns:xslthl="http://xslthl.sf.net" href="jacoco_plugin.html" title="The JaCoCo Plugin - Gradle User Guide Version 4.2">Previous</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="userguide.html" title="Gradle User Guide Version 4.2">Contents</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="eclipse_plugin.html" title="The Eclipse Plugins - Gradle User Guide Version 4.2">Next</a></div></div></div><div class="chapter"><div class="titlepage"><div><div><h1 xmlns:xslthl="http://xslthl.sf.net"><a name="osgi_plugin"></a>Chapter&nbsp;65.&nbsp;The OSGi Plugin</h1></div></div></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="section"><a href="osgi_plugin.html#sec:osgi_usage">65.1. Usage</a></span></dt><dt><span class="section"><a href="osgi_plugin.html#sec:osgi_implicitly_applied_plugins">65.2. Implicitly applied plugins</a></span></dt><dt><span class="section"><a href="osgi_plugin.html#sec:osgi_tasks">65.3. Tasks</a></span></dt><dt><span class="section"><a href="osgi_plugin.html#sec:osgi_convention_object">65.4. Convention object</a></span></dt></dl></div><p>The OSGi plugin provides a factory method to create an
        <a class="ulink" href="../javadoc/org/gradle/api/plugins/osgi/OsgiManifest.html" target="_top"><code class="classname">OsgiManifest</code></a> object. <code class="literal">OsgiManifest</code> extends
        <a class="ulink" href="../javadoc/org/gradle/api/java/archives/Manifest.html" target="_top"><code class="classname">Manifest</code></a>. To learn more
        about generic manifest handling, see <a class="xref" href="java_plugin.html#sub:manifest">Section&nbsp;47.15.1, &ldquo;Manifest&rdquo;</a>. If the Java plugins is applied, the OSGi plugin
        replaces the manifest object of the default jar with an <code class="literal">OsgiManifest</code> object. The replaced manifest
        is merged into the new one.
    </p><div class="note">
        The OSGi plugin makes heavy use of the <a class="ulink" href="http://bnd.bndtools.org/" target="_top">BND tool</a>.
        A separate <a class="ulink" href="https://github.com/bndtools/bnd/blob/master/biz.aQute.bnd.gradle/README.md" target="_top">plugin implementation</a> is maintained by the BND authors that has more advanced features.
    </div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:osgi_usage" class="section-anchor" href="#sec:osgi_usage"></a>65.1.&nbsp;Usage</h2></div></div></div><p>To use the OSGi plugin, include the following in your build script:</p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="useOsgiPlugin"></a><p class="title"><b>Example&nbsp;65.1.&nbsp;Using the OSGi plugin</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">apply plugin: <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'osgi'</span>
</pre></div></div><br class="example-break"></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:osgi_implicitly_applied_plugins" class="section-anchor" href="#sec:osgi_implicitly_applied_plugins"></a>65.2.&nbsp;Implicitly applied plugins</h2></div></div></div><p>Applies the Java base plugin.</p></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:osgi_tasks" class="section-anchor" href="#sec:osgi_tasks"></a>65.3.&nbsp;Tasks</h2></div></div></div><p>The OSGi plugin adds the following tasks to the project:</p><div xmlns:xslthl="http://xslthl.sf.net" class="table"><p class="title"><b>Table&nbsp;65.1.&nbsp;OSGi plugin - tasks</b></p><div class="table-contents"><table id="N1879F"><thead><tr>
                    <td>Task name</td>
                    <td>Depends on</td>
                    <td>Type</td>
                    <td>Description</td>
                </tr></thead><tr>
                <td>
                    <code class="literal">osgiClasses</code>
                </td>
                <td><code class="literal">classes</code></td>
                <td><a class="ulink" href="../dsl/org.gradle.api.tasks.Sync.html" target="_top"><code class="classname">Sync</code></a></td>
                <td>Copies all classes from the main source set to a single directory that is processed by BND.</td>
            </tr></table></div></div></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:osgi_convention_object" class="section-anchor" href="#sec:osgi_convention_object"></a>65.4.&nbsp;Convention object</h2></div></div></div><p>The OSGi plugin adds the following convention object: <a class="ulink" href="../dsl/org.gradle.api.plugins.osgi.OsgiPluginConvention.html" target="_top"><code class="classname">OsgiPluginConvention</code></a>
        </p><div class="section"><div class="titlepage"><div><div><h3 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:osgi_convention_properties" class="section-anchor" href="#sec:osgi_convention_properties"></a>65.4.1.&nbsp;Convention properties</h3></div></div></div><p>The OSGi plugin does not add any convention properties to the project.
            </p></div><div class="section"><div class="titlepage"><div><div><h3 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:osgi_convention_methods" class="section-anchor" href="#sec:osgi_convention_methods"></a>65.4.2.&nbsp;Convention methods</h3></div></div></div><p>The OSGi plugin adds the following methods. For more details, see the API documentation of the convention
                object.
            </p><div xmlns:xslthl="http://xslthl.sf.net" class="table"><p class="title"><b>Table&nbsp;65.2.&nbsp;OSGi methods</b></p><div class="table-contents"><table id="N187DD"><thead><tr>
                        <td>Method</td>
                        <td>Return Type</td>
                        <td>Description</td>
                    </tr></thead><tr>
                    <td>osgiManifest()</td>
                    <td>
                        <a class="ulink" href="../javadoc/org/gradle/api/plugins/osgi/OsgiManifest.html" target="_top"><code class="classname">OsgiManifest</code></a>
                    </td>
                    <td>Returns an OsgiManifest object.</td>
                </tr><tr>
                    <td>osgiManifest(Closure cl)</td>
                    <td>
                        <a class="ulink" href="../javadoc/org/gradle/api/plugins/osgi/OsgiManifest.html" target="_top"><code class="classname">OsgiManifest</code></a>
                    </td>
                    <td>Returns an OsgiManifest object configured by the closure.</td>
                </tr></table></div></div><p>The classes in the classes dir are analyzed regarding their package dependencies and the packages they expose.
                Based on this the <span class="emphasis"><em>Import-Package</em></span> and the <span class="emphasis"><em>Export-Package</em></span> values of the
                OSGi Manifest are calculated. If the classpath contains jars with an OSGi bundle, the bundle
                information is used to specify version information for the <span class="emphasis"><em>Import-Package</em></span>
                value. Beside the explicit properties of the <code class="literal">OsgiManifest</code> object you can add instructions.
            </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="osgi"></a><p class="title"><b>Example&nbsp;65.2.&nbsp;Configuration of OSGi MANIFEST.MF file</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">jar {
    manifest { <span xmlns:xslthl="http://xslthl.sf.net" class="hl-comment">// the manifest of the default jar is of type OsgiManifest</span>
        name = <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'overwrittenSpecialOsgiName'</span>
        instruction <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'Private-Package'</span>,
                <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'org.mycomp.package1'</span>,
                <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'org.mycomp.package2'</span>
        instruction <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'Bundle-Vendor'</span>, <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'MyCompany'</span>
        instruction <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'Bundle-Description'</span>, <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'Platform2: Metrics 2 Measures Framework'</span>
        instruction <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'Bundle-DocURL'</span>, <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'http://www.mycompany.com'</span>
    }
}
task fooJar(type: Jar) {
    manifest = osgiManifest {
        instruction <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'Bundle-Vendor'</span>, <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'MyCompany'</span>    
    }
}
</pre></div></div><br class="example-break"><p>The first argument of the instruction call is the key of the property. The other arguments form the value.
                To learn more about the available instructions have a look at the <a class="ulink" href="http://www.aqute.biz/Bnd/Bnd" target="_top">BND tool</a>.</p></div></div></div><div class="navfooter"><div><div class="navbar"><a xmlns:xslthl="http://xslthl.sf.net" href="jacoco_plugin.html" title="The JaCoCo Plugin - Gradle User Guide Version 4.2">Previous</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="userguide.html" title="Gradle User Guide Version 4.2">Contents</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="eclipse_plugin.html" title="The Eclipse Plugins - Gradle User Guide Version 4.2">Next</a></div></div></div></body></html>